VERSION 5.00
Begin VB.Form frmMidi 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Midi"
   ClientHeight    =   1245
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4785
   Icon            =   "frmMidi.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1245
   ScaleWidth      =   4785
   StartUpPosition =   2  'CenterScreen
   Begin VB.FileListBox File1 
      Height          =   1260
      Left            =   0
      Pattern         =   "*.mid"
      TabIndex        =   2
      Top             =   0
      Width           =   3375
   End
   Begin VB.CommandButton bPlay 
      Caption         =   "Play"
      Default         =   -1  'True
      Height          =   375
      Left            =   3600
      TabIndex        =   1
      Top             =   120
      Width           =   1035
   End
   Begin VB.CommandButton bStop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   3600
      TabIndex        =   0
      Top             =   720
      Width           =   1035
   End
End
Attribute VB_Name = "frmMidi"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private dx As New DirectX8
Private dml As DirectMusicLoader8
Private dmp As DirectMusicPerformance8
Private seg As DirectMusicSegment8

Private Sub bPlay_Click()
  If File1.ListIndex < 0 Then Exit Sub
  Set seg = dml.LoadSegment(File1.List(File1.ListIndex))
  seg.Download dmp.GetDefaultAudioPath
  dmp.PlaySegmentEx seg, DMUS_SEGF_DEFAULT, 0
End Sub

Private Sub bStop_Click()
  If dmp.IsPlaying(seg, Nothing) Then dmp.StopEx dmp.GetDefaultAudioPath, 0&, DMUS_SEGF_DEFAULT
End Sub

Private Sub File1_DblClick()
  bPlay_Click
End Sub

Private Sub Form_Load()
Dim dmA As DMUS_AUDIOPARAMS
  Set dml = dx.DirectMusicLoaderCreate
  Set dmp = dx.DirectMusicPerformanceCreate
  dmp.InitAudio Me.hWnd, DMUS_AUDIOF_ALL, dmA, Nothing, DMUS_APATH_SHARED_STEREOPLUSREVERB, 64
  dml.SetSearchDirectory App.Path
End Sub

Private Sub Form_Unload(Cancel As Integer)
  If Not seg Is Nothing Then
    If dmp.IsPlaying(seg, Nothing) Then dmp.StopEx dmp.GetDefaultAudioPath, 0&, DMUS_SEGF_DEFAULT
  End If
  Set seg = Nothing
  dmp.CloseDown
  Set dmp = Nothing
  Set dml = Nothing
  Set dx = Nothing
End Sub
